/*
 * main.c
 */
#include <c6x.h>
#define		INTC_BASE		0x01800000
#define		INTMUX1			(INTC_BASE+0x104)
#define		INTMUX2			(INTC_BASE+0x108)
#define		INTMUX3			(INTC_BASE+0x10C)

#define		PDCCMD			0x01810000

#define		TIMER0_BASE		0x01C20000
#define		PRD12			(TIMER0_BASE+0x18)
#define		TCR				(TIMER0_BASE+0x20)
#define		TGCR			(TIMER0_BASE+0x24)

void main(void) {
	
	ISTP = 0x11800000;
	*(volatile unsigned int *)INTMUX1 = 0x07060504;
	*(volatile unsigned int *)INTMUX2 = 0x0B0A4376;
	IER |= 0xFFF2;    // Enable interrupts
	CSR |= 0x1;      // Enable GIE

	asm(" nop ");
	asm(" nop ");
	asm(" nop ");
	asm(" nop ");
	asm(" nop ");
	asm(" nop ");
	asm(" nop ");

	// Timer generate interrupt
	*(volatile unsigned int *)PRD12 = 0x08000000;
	*(volatile unsigned int *)TCR   = 0x80;
	*(volatile unsigned int *)TGCR  = 0x3;

	// transite to idle state
	*(volatile unsigned int *)PDCCMD = 0x00010000;//0x00015555;
	asm(" idle ");   // sleep

	while(1);

}

interrupt void pdcISR(void)
{

}
